<?php
/**
 * Plugin FAQ Parser
 * 
 * @package    Plugin FAQ Parser
 * @subpackage PluginFaqParser Main Functions
/*  Copyright (c) 2016- Katsushi Kawamori (email : dodesyoswift312@gmail.com)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class PluginFaqParser {

	public $pfq_slug;
	public $pfq_theme;

	/* ==================================================
	* @param	string	$atts
	* @return	string	$content
	* @since	1.0
	*/
	function main_func( $atts, $content = NULL ) {

		extract(shortcode_atts(array(
			'slug'	=> '',
			'theme' => ''
		), $atts));

		if ( !empty($slug) ) {
			$faq = NULL;
			if( get_transient( 'pluginfaq_datas_'.$slug.'_'.get_locale() ) ) {
				// Get cache
				$faq = get_transient( 'pluginfaq_datas_'.$slug.'_'.get_locale() );
			} else {
				// Call API
				require_once ABSPATH.'wp-admin/includes/plugin-install.php';
				$call_api = plugins_api( 'plugin_information', array( 'slug' => $slug,
																	'fields' => array('sections'=> TRUE)
																	 )
										);
			    if ( is_wp_error( $call_api ) ) {
					// skip
			    } else {
					$sections = $call_api->sections;
					if ( array_key_exists( "faq", $sections ) ) {
						$faq = $sections['faq'];
					} else {
						return "";
					}
					// Set cache
					set_transient( 'pluginfaq_datas_'.$slug.'_'.get_locale(), $faq, 86400 );
				}
			}

			if ( !empty($theme) ) {
				$this->pfq_slug = $slug;
				$this->pfq_theme = $theme;
				$content = '<div id="pluginfaqparser-'.$slug.'-accordion">';
				$content .= $faq;
				$content .= '</div>';
				$content = str_replace('<p>', '<div>', $content);
				$content = str_replace('</p>', '</div>', $content);
			} else {
				$content = $faq;
			}
			return do_shortcode($content);
		} else {
			return "";
		}

	}

	/* ==================================================
	 * @param	none
	 * @return	int		$del_cash_count
	 * @since	1.0
	 */
	function delete_all_cash(){

		global $wpdb;
		$search_transients = 'pluginfaq_datas_';
		$del_transients = $wpdb->get_results("
						SELECT	option_name
						FROM	$wpdb->options
						WHERE	option_name LIKE '%%$search_transients%%'
						");

		$del_cash_count = 0;
		foreach ( $del_transients as $del_transient ) {
			$transient = str_replace ( '_transient_', '', $del_transient->option_name );
			$value_del_cash = get_transient( $transient );
			if ( $value_del_cash <> FALSE ) {
				delete_transient( $transient );
				++$del_cash_count;
			}
		}

		return $del_cash_count;

	}

	/* ==================================================
	* Load Localize Script and Style
	* @param	none
	* @since	1.03
	*/
	function load_localize_scripts_styles() {

		if ( !empty($this->pfq_theme) ) {
			global $wp_scripts;
			wp_enqueue_style('jquery-ui', "https://ajax.googleapis.com/ajax/libs/jqueryui/{$wp_scripts->registered['jquery-ui-core']->ver}/themes/{$this->pfq_theme}/jquery-ui.min.css");
			wp_enqueue_script( 'jquery' );
			wp_enqueue_script( 'jquery-ui-accordion' );

			wp_enqueue_script( 'pluginfaqparser-jquery', PLUGINFAQPARSER_PLUGIN_URL.'/js/jquery.pluginfaqparser.js', array('jquery') );
			wp_localize_script( 'pluginfaqparser-jquery', 'pluginfaqparser_slug', $this->pfq_slug );
		}

	}

}

?>